Attribute VB_Name = "Module1"
Public Declare Function timeGetTime Lib "winmm.dll" () As Long

Public outdata() As Byte
Public dat_temp() As Long

Public crc_l As Byte
Public crc_h As Byte
Public serial_num As Byte
Public interface_flag As Byte
Public baud As String
Public usart_baud As String
Public device_id As Integer
Public suoding_flag As Integer
Public cmd_num_flag As Integer
Public zt_flag As Byte
Public fs_flag As Byte

'****ʱ,λǺ,֧С****
Public Function YanShi(HaoMiao As Double)
    Dim t1
    t1 = timeGetTime
    While (timeGetTime - t1) < HaoMiao
        DoEvents
    Wend
End Function

Public Function crc16(data() As Byte) As String
    Dim CRC16Lo As Byte, CRC16Hi As Byte
    Dim CL As Byte, CH As Byte
    Dim SaveHi As Byte, SaveLo As Byte
    Dim i As Integer
    Dim Flag As Integer
    
    CRC16Lo = &HFF
    CRC16Hi = &HFF
    CL = &H1
    CH = &HA0
    
    For i = 0 To UBound(data)
        CRC16Lo = CRC16Lo Xor data(i)
        
        For Flag = 0 To 7
            SaveHi = CRC16Hi
            SaveLo = CRC16Lo
            CRC16Hi = CRC16Hi \ 2
            CRC16Lo = CRC16Lo \ 2
            If ((SaveHi And &H1) = &H1) Then
                CRC16Lo = CRC16Lo Or &H80
            End If
            If ((SaveLo And &H1) = &H1) Then
                CRC16Hi = CRC16Hi Xor CH
                CRC16Lo = CRC16Lo Xor CL
            End If
        Next Flag
    Next i
    
    crc_l = CRC16Lo
    crc_h = CRC16Hi
  
 End Function

Public Function Coil_ON(dev As Integer, add1 As Integer)   '1 5 0 0 FF 0 8C 3A
    Dim temp0 As Byte
    Dim temp1 As Byte

    
    temp0 = Int(add1 / 256)         'λ
    temp1 = add1 - temp0 * 256      'λ
    
    
    ReDim outdata(5) As Byte
    outdata(0) = dev
    outdata(1) = 5
    outdata(2) = temp0
    outdata(3) = temp1
    outdata(4) = &HFF
    outdata(5) = 0
    Call crc16(outdata)

    ReDim Preserve outdata(7) As Byte    'Preserve  ضͻᱣԭݣ
    outdata(6) = crc_l
    outdata(7) = crc_h
    
    If interface_flag = 1 Then
        Form1.MSComm1.Output = outdata
    End If
End Function

Public Function Coil_OFF(dev As Integer, add1 As Integer)
    Dim temp0 As Byte
    Dim temp1 As Byte

    
    temp0 = Int(add1 / 256)         'λ
    temp1 = add1 - temp0 * 256      'λ

    ReDim outdata(5) As Byte
    outdata(0) = dev
    outdata(1) = 5
    outdata(2) = temp0
    outdata(3) = temp1
    outdata(4) = 0
    outdata(5) = 0
    Call crc16(outdata)
    
    ReDim Preserve outdata(7) As Byte
    outdata(6) = crc_l
    outdata(7) = crc_h
    
End Function

 'дĴ   -豸  Ĵʼַ  Ĵ  ֽڸ=Ĵ*2  
            'Ĵ֪  Ϳֽڸ,  ĴС
Public Function WR_N_REG(dev As Integer, add1 As Integer, num1 As Integer)
    Dim temp0 As Byte
    Dim temp1 As Byte
    Dim temp2 As Byte
    Dim temp3 As Byte
    
    Dim temp4 As Integer
    Dim temp5 As Byte
    Dim i As Integer
    Dim j As Integer
    

    temp0 = Int(add1 / 256)         'λ
    temp1 = add1 - temp0 * 256      'λ
    
    temp2 = Int(num1 / 256)         'λ   Ĵ
    temp3 = num1 - temp2 * 256      'λ
    
    temp4 = num1 * 2                'ֽڸ=Ĵ*2
    ReDim outdata(7 + temp4 - 1) As Byte
    
    outdata(0) = dev
    outdata(1) = &H10
    outdata(2) = temp0
    outdata(3) = temp1
    outdata(4) = temp2
    outdata(5) = temp3
    outdata(6) = temp4              'ֽڸ
   
    j = 0
    For i = 0 To temp4 - 1 Step 2
        temp5 = Int(dat_temp(j) / 256) 'м
        outdata(7 + i) = temp5      'λ
        outdata(7 + i + 1) = (dat_temp(j) - temp5 * 256&)    'λ  temp5 * 256˴ܻᳬͣ
        
        j = j + 1
    Next i

    Call crc16(outdata)
     
    ReDim Preserve outdata(7 + temp4 + 1) As Byte   'ֽܹڸ = 7+temp4+2
    outdata(7 + temp4) = crc_l
    outdata(7 + temp4 + 1) = crc_h
      
    If interface_flag = 1 Then
        Form1.MSComm1.Output = outdata
    End If
End Function

 'д1Ĵ   -豸  Ĵʼַ   
Public Function WR_1_REG(dev As Integer, add1 As Integer, dat As Integer)
    Dim temp0 As Byte
    Dim temp1 As Byte
    Dim temp2 As Byte
    Dim temp3 As Byte
    Dim temp4 As Byte
    Dim temp5 As Byte
    Dim temp6 As Byte
    ReDim outdata(5) As Byte

    
    temp0 = Int(add1 / 256)         'λ
    temp1 = add1 - temp0 * 256      'λ
    
    temp2 = Int(dat / 256)         'λ
    temp3 = dat - temp2 * 256      'λ
        
    outdata(0) = dev
    outdata(1) = &H6
    outdata(2) = temp0
    outdata(3) = temp1
    outdata(4) = temp2
    outdata(5) = temp3

    Call crc16(outdata)
     
    ReDim Preserve outdata(7) As Byte
    outdata(6) = crc_l
    outdata(7) = crc_h
    
     If interface_flag = 1 Then
        Form1.MSComm1.Output = outdata
    End If
End Function

'Ĵ   -豸  Ĵʼַ  Ĵĸ   01 03 00 00 00 01 84 0a
Public Function RD_N_REG(dev As Integer, add1 As Integer, num1 As Integer)
    Dim temp0 As Byte
    Dim temp1 As Byte
    Dim temp2 As Byte
    Dim temp3 As Byte
    ReDim outdata(5) As Byte
    
    temp0 = Int(add1 / 256)         'λ
    temp1 = add1 - temp0 * 256      'λ
    
    temp2 = Int(num1 / 256)         'λ
    temp3 = num1 - temp2 * 256      'λ
    
    outdata(0) = dev
    outdata(1) = 3
    outdata(2) = temp0
    outdata(3) = temp1
    outdata(4) = temp2
    outdata(5) = temp3
    Call crc16(outdata)
     
    ReDim Preserve outdata(7) As Byte
    outdata(6) = crc_l
    outdata(7) = crc_h
    
    If interface_flag = 1 Then
        Form1.MSComm1.Output = outdata
    End If
End Function

 




